/* 
 * keyshades
 * a tool for disabling the treo keyboard backlight
 * copyright (c) 2005, daniel grobe sachs <dgsachs@nekito.net>
 *
 * This is free software. See included LICENSE file for details.
 */

#include <PalmOS.h>
#include <palmOne_68K.h>
#include <68K/System/HsExt.h>
#include <Common/System/HsExtCommon.h>

#include "resource.h"

#define DefaultLit 0

// Lights tools
#define LightsAreOn() (!(HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit))

static void SetLights(Boolean state)
{
	// turn on if requested
	while( state && !LightsAreOn())
		HsLightCircumstance(false,hsLightCircumstanceKeylightOff);

	// turn off if requested
	if( !state && LightsAreOn() )
		HsLightCircumstance(true,hsLightCircumstanceKeylightOff);
}

#define ToggleLights() SetLights(!LightsAreOn())
							

//// PilotMain /////////////////////////////////////////////////////////
// It all starts here...

UInt32 PilotMain(UInt16 launchCode, MemPtr cmdPBP, UInt16 launchFlags) 
{
	Err err = 0;
	EventType event;

	switch( launchCode ) 
	{
		case sysAppLaunchCmdSystemReset :
			SetLights(DefaultLit);
			break;

		case sysAppLaunchCmdNormalLaunch :
			// Well, uh, we don't have a UI, so we just quit
			ToggleLights();
			MemSet( &event, sizeof(event), 0);

			event.eType = appStopEvent;
			EvtAddEventToQueue(&event);
			break;

		default:
			break;
	}


	return err;
}

